diff -uNr unrar/extract.cpp unrar/extract.cpp
--- unrar/extract.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/extract.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -25,6 +25,7 @@
   while (Cmd->GetArcName(ArcName,ArcNameW,sizeof(ArcName)))
     if (FindFile::FastFind(ArcName,ArcNameW,&FD))
       DataIO.TotalArcSize+=FD.Size;
+
   Cmd->ArcNames->Rewind();
   while (Cmd->GetArcName(ArcName,ArcNameW,sizeof(ArcName)))
   {
@@ -35,10 +36,8 @@
 
       EXTRACT_ARC_CODE Code=ExtractArchive(Cmd);
 
-/*
-      restore Cmd->Password which could be changed in IsArchive() call
-      for next header encrypted archive
-*/
+      // restore Cmd->Password which could be changed in IsArchive() call
+      // for next header encrypted archive
       strcpy(Cmd->Password,PrevCmdPassword);
 
       if (Code!=EXTRACT_ARC_REPEAT)
@@ -54,7 +53,7 @@
     {
       mprintf(St(MExtrNoFiles));
     }
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
   }
 #ifndef GUI
   else
@@ -90,6 +89,8 @@
   SignatureFound=false;
   AllMatchesExact=true;
   ReconstructDone=false;
+
+  StartTime.SetCurrentTime();
 }
 
 
@@ -98,7 +99,7 @@
   Archive Arc(Cmd);
   if (!Arc.WOpen(ArcName,ArcNameW))
   {
-    ErrHandler.SetErrorCode(RAR_OPEN_ERROR);
+    ErrHandler.SetErrorCode(OPEN_ERROR);
     return(EXTRACT_ARC_NEXT);
   }
 
@@ -108,10 +109,11 @@
     mprintf(St(MNotRAR),ArcName);
 #endif
     if (CmpExt(ArcName,"rar"))
-      ErrHandler.SetErrorCode(RAR_WARNING);
+      ErrHandler.SetErrorCode(WARNING);
     return(EXTRACT_ARC_NEXT);
   }
 
+  // archive with corrupt encrypted header can be closed in IsArchive() call
   if (!Arc.IsOpened())
     return(EXTRACT_ARC_NEXT);
 
@@ -119,13 +121,42 @@
   if (Arc.Volume && Arc.NotFirstVolume)
   {
     char FirstVolName[NM];
-
     VolNameToFirstName(ArcName,FirstVolName,(Arc.NewMhd.Flags & MHD_NEWNUMBERING));
+
+    // If several volume names from same volume set are specified
+    // and current volume is not first in set and first volume is present
+    // and specified too, let's skip the current volume.
     if (stricomp(ArcName,FirstVolName)!=0 && FileExist(FirstVolName) &&
         Cmd->ArcNames->Search(FirstVolName,NULL,false))
       return(EXTRACT_ARC_NEXT);
   }
 #endif
+
+  if (Arc.Volume)
+  {
+    // Calculate the total size of all accessible volumes.
+    // This size is necessary to display the correct total progress indicator.
+
+    char NextName[NM];
+    wchar NextNameW[NM];
+
+    strcpy(NextName,Arc.FileName);
+    strcpyw(NextNameW,Arc.FileNameW);
+
+    while (true)
+    {
+      // First volume is already added to DataIO.TotalArcSize 
+      // in initial TotalArcSize calculation in DoExtract.
+      // So we skip it and start from second volume.
+      NextVolumeName(NextName,NextNameW,ASIZE(NextName),(Arc.NewMhd.Flags & MHD_NEWNUMBERING)==0 || Arc.OldFormat);
+      struct FindData FD;
+      if (FindFile::FastFind(NextName,NextNameW,&FD))
+        DataIO.TotalArcSize+=FD.Size;
+      else
+        break;
+    }
+  }
+
   ExtractArchiveInit(Cmd,Arc);
 
   if (*Cmd->Command=='T' || *Cmd->Command=='I')
@@ -174,9 +205,9 @@
 #ifdef NOVOLUME
       return(false);
 #else
-      if (!MergeArchive(Arc,NULL,false,Command))
+      if (!MergeArchive(Arc,&DataIO,false,Command))
       {
-        ErrHandler.SetErrorCode(RAR_WARNING);
+        ErrHandler.SetErrorCode(WARNING);
         return(false);
       }
       SignatureFound=false;
@@ -206,9 +237,9 @@
       if (Arc.EndArcHead.Flags & EARC_NEXT_VOLUME)
       {
 #ifndef NOVOLUME
-        if (!MergeArchive(Arc,NULL,false,Command))
+        if (!MergeArchive(Arc,&DataIO,false,Command))
         {
-          ErrHandler.SetErrorCode(RAR_WARNING);
+          ErrHandler.SetErrorCode(WARNING);
           return(false);
         }
         SignatureFound=false;
@@ -352,7 +383,7 @@
 #ifdef RARDLL
       Cmd->DllError=ERAR_BAD_DATA;
 #endif
-      ErrHandler.SetErrorCode(RAR_WARNING);
+      ErrHandler.SetErrorCode(OPEN_ERROR);
     }
     ExactMatch=false;
   }
@@ -370,7 +401,7 @@
 #ifdef RARDLL
         if (*Cmd->Password==0)
           if (Cmd->Callback==NULL ||
-              Cmd->Callback(UCM_NEEDPASSWORD,Cmd->UserData,(LONG)Cmd->Password,sizeof(Cmd->Password))==-1)
+              Cmd->Callback(UCM_NEEDPASSWORD,Cmd->UserData,(LPARAM)Cmd->Password,sizeof(Cmd->Password))==-1)
             return(false);
         strcpy(Password,Cmd->Password);
 
@@ -390,7 +421,7 @@
           switch(Cmd->AllYes ? 1:Ask(St(MYesNoAll)))
           {
             case -1:
-              ErrHandler.Exit(RAR_USER_BREAK);
+              ErrHandler.Exit(USER_BREAK);
             case 2:
               if (!GetPassword(PASSWORD_FILE,ArcFileName,Password,sizeof(Password)))
               {
@@ -488,7 +519,7 @@
       if (Length>0)
       {
         wchar ArcPathW[NM];
-        CharToWide(Cmd->ArcPath,ArcPathW);
+        GetWideName(Cmd->ArcPath,Cmd->ArcPathW,ArcPathW);
         Length=strlenw(ArcPathW);
       }
       ExtrNameW+=Length;
@@ -518,7 +549,16 @@
       if (FindFile::FastFind(DestFileName,DestNameW,&FD))
       {
         if (FD.mtime >= Arc.NewLhd.mtime)
-          ExtrFile=false;
+        {
+          // If directory already exists and its modification time is newer 
+          // than start of extraction, it is likely it was created 
+          // when creating a path to one of already extracted items. 
+          // In such case we'll better update its time even if archived 
+          // directory is older.
+
+          if (!FD.IsDir || FD.mtime<StartTime)
+            ExtrFile=false;
+        }
       }
       else
         if (Cmd->FreshFiles)
@@ -528,7 +568,7 @@
     // skip encrypted file if no password is specified
     if ((Arc.NewLhd.Flags & LHD_PASSWORD)!=0 && *Password==0)
     {
-      ErrHandler.SetErrorCode(RAR_WARNING);
+      ErrHandler.SetErrorCode(WARNING);
 #ifdef RARDLL
       Cmd->DllError=ERAR_MISSING_PASSWORD;
 #endif
@@ -566,7 +606,7 @@
 #endif
 #endif
       ExtrFile=false;
-      ErrHandler.SetErrorCode(RAR_WARNING);
+      ErrHandler.SetErrorCode(WARNING);
 #ifdef RARDLL
       Cmd->DllError=ERAR_UNKNOWN_FORMAT;
 #endif
@@ -630,16 +670,16 @@
 #ifdef RARDLL
             Cmd->DllError=ERAR_ECREATE;
 #endif
-            ErrHandler.SetErrorCode(RAR_CREATE_ERROR);
+            ErrHandler.SetErrorCode(CREATE_ERROR);
           }
         if (PrevExtracted)
         {
 #if defined(_WIN_32) && !defined(_WIN_CE) && !defined(SFX_MODULE)
           if (Cmd->SetCompressedAttr &&
               (Arc.NewLhd.FileAttr & FILE_ATTRIBUTE_COMPRESSED)!=0 && WinNT())
-            SetFileCompression(DestFileName,DestFileNameW,true);
+            SetFileCompression(DestFileName,DestNameW,true);
 #endif
-          SetDirTime(DestFileName,
+          SetDirTime(DestFileName,DestNameW,
             Cmd->xmtime==EXTTIME_NONE ? NULL:&Arc.NewLhd.mtime,
             Cmd->xctime==EXTTIME_NONE ? NULL:&Arc.NewLhd.ctime,
             Cmd->xatime==EXTTIME_NONE ? NULL:&Arc.NewLhd.atime);
@@ -663,7 +703,7 @@
             if (!UserReject)
             {
               ErrHandler.CreateErrorMsg(Arc.FileName,DestFileName);
-              ErrHandler.SetErrorCode(RAR_CREATE_ERROR);
+              ErrHandler.SetErrorCode(CREATE_ERROR);
 #ifdef RARDLL
               Cmd->DllError=ERAR_ECREATE;
 #endif
@@ -796,7 +836,7 @@
             Log(BadArcName,St(MCRCFailed),ArcFileName);
           }
           BrokenFile=true;
-          ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+          ErrHandler.SetErrorCode(CRC_ERROR);
 #ifdef RARDLL
           Cmd->DllError=ERAR_BAD_DATA;
 #endif
diff -uNr unrar/extract.hpp unrar/extract.hpp
--- unrar/extract.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/extract.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -7,6 +7,7 @@
 {
   private:
     EXTRACT_ARC_CODE ExtractArchive(CommandData *Cmd);
+    RarTime StartTime; // time when extraction started
 
     ComprDataIO DataIO;
     Unpack *Unp;
diff -uNr unrar/filcreat.cpp unrar/filcreat.cpp
--- unrar/filcreat.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/filcreat.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -30,7 +30,7 @@
 #endif
     if (Cmd->AllYes || Mode==OVERWRITE_ALL)
       break;
-    if (Mode==OVERWRITE_ASK)
+    if (Mode==OVERWRITE_DEFAULT || Mode==OVERWRITE_FORCE_ASK)
     {
       eprintf(St(MFileExists),Name);
       int Choice=Ask(St(MYesNoAllRenQ));
@@ -78,7 +78,7 @@
         continue;
       }
       if (Choice==6)
-        ErrHandler.Exit(RAR_USER_BREAK);
+        ErrHandler.Exit(USER_BREAK);
     }
     if (Mode==OVERWRITE_AUTORENAME)
     {
@@ -88,7 +88,7 @@
           *NameW=0;
       }
       else
-        Mode=OVERWRITE_ASK;
+        Mode=OVERWRITE_DEFAULT;
       continue;
     }
   }
diff -uNr unrar/file.cpp unrar/file.cpp
--- unrar/file.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/file.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -121,7 +121,7 @@
 void File::TOpen(const char *Name,const wchar *NameW)
 {
   if (!WOpen(Name,NameW))
-    ErrHandler.Exit(RAR_OPEN_ERROR);
+    ErrHandler.Exit(OPEN_ERROR);
 }
 #endif
 
@@ -135,14 +135,15 @@
 }
 
 
-bool File::Create(const char *Name,const wchar *NameW)
+bool File::Create(const char *Name,const wchar *NameW,bool ShareRead)
 {
 #ifdef _WIN_32
+  DWORD ShareMode=(ShareRead || File::OpenShared) ? FILE_SHARE_READ:0;
   if (WinNT() && NameW!=NULL && *NameW!=0)
-    hFile=CreateFileW(NameW,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ,NULL,
+    hFile=CreateFileW(NameW,GENERIC_READ|GENERIC_WRITE,ShareMode,NULL,
                       CREATE_ALWAYS,0,NULL);
   else
-    hFile=CreateFile(Name,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ,NULL,
+    hFile=CreateFile(Name,GENERIC_READ|GENERIC_WRITE,ShareMode,NULL,
                      CREATE_ALWAYS,0,NULL);
 #else
   hFile=fopen(Name,CREATEBINARY);
@@ -176,19 +177,19 @@
 
 
 #if !defined(SHELL_EXT) && !defined(SFX_MODULE)
-void File::TCreate(const char *Name,const wchar *NameW)
+void File::TCreate(const char *Name,const wchar *NameW,bool ShareRead)
 {
-  if (!WCreate(Name,NameW))
-    ErrHandler.Exit(RAR_FATAL_ERROR);
+  if (!WCreate(Name,NameW,ShareRead))
+    ErrHandler.Exit(FATAL_ERROR);
 }
 #endif
 
 
-bool File::WCreate(const char *Name,const wchar *NameW)
+bool File::WCreate(const char *Name,const wchar *NameW,bool ShareRead)
 {
-  if (Create(Name,NameW))
+  if (Create(Name,NameW,ShareRead))
     return(true);
-  ErrHandler.SetErrorCode(RAR_CREATE_ERROR);
+  ErrHandler.SetErrorCode(CREATE_ERROR);
   ErrHandler.CreateErrorMsg(Name);
   return(false);
 }
@@ -248,15 +249,21 @@
 }
 
 
-bool File::Rename(const char *NewName)
+bool File::Rename(const char *NewName,const wchar *NewNameW)
 {
+  // we do not need to rename if names are already same
   bool Success=strcmp(FileName,NewName)==0;
+  if (Success && *FileNameW!=0 && *NullToEmpty(NewNameW)!=0)
+    Success=strcmpw(FileNameW,NewNameW)==0;
+
   if (!Success)
-    Success=rename(FileName,NewName)==0;
+    Success=RenameFile(FileName,FileNameW,NewName,NewNameW);
+
   if (Success)
   {
+    // renamed successfully, storing the new name
     strcpy(FileName,NewName);
-    *FileNameW=0;
+    strcpyw(FileNameW,NullToEmpty(NewNameW));
   }
   return(Success);
 }
@@ -288,11 +295,12 @@
 #endif
   while (1)
   {
-    bool Success;
+    bool Success=false;
 #ifdef _WIN_32
-    DWORD Written;
+    DWORD Written=0;
     if (HandleType!=FILE_HANDLENORMAL)
     {
+      // writing to stdout can fail in old Windows if data block is too large
       const int MaxSize=0x4000;
       for (int I=0;I<Size;I+=MaxSize)
         if (!(Success=WriteFile(hFile,(byte *)Data+I,Min(Size-I,MaxSize),&Written,NULL)))
@@ -333,7 +341,8 @@
 
 int File::Read(void *Data,int Size)
 {
-  Int64 FilePos;
+  Int64 FilePos=0; //initialized only to suppress some compilers warning
+
   if (IgnoreReadErrors)
     FilePos=Tell();
   int ReadSize;
diff -uNr unrar/filefn.cpp unrar/filefn.cpp
--- unrar/filefn.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/filefn.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -31,9 +31,9 @@
   return(errno==ENOENT ? MKDIR_BADPATH:MKDIR_ERROR);
 #endif
 #ifdef _UNIX
-  int prevmask=umask(0);
+//  int prevmask=umask(0);
   int ErrCode=Name==NULL ? -1:mkdir(Name,(mode_t)Attr);
-  umask(prevmask);
+//  umask(prevmask);
   if (ErrCode==-1)
     return(errno==ENOENT ? MKDIR_BADPATH:MKDIR_ERROR);
   return(MKDIR_SUCCESS);
@@ -109,7 +109,7 @@
 }
 
 
-void SetDirTime(const char *Name,RarTime *ftm,RarTime *ftc,RarTime *fta)
+void SetDirTime(const char *Name,const wchar *NameW,RarTime *ftm,RarTime *ftc,RarTime *fta)
 {
 #ifdef _WIN_32
   if (!WinNT())
@@ -119,11 +119,14 @@
   bool sc=ftc!=NULL && ftc->IsSet();
   bool sa=fta!=NULL && fta->IsSet();
 
-  unsigned int DirAttr=GetFileAttr(Name);
+  unsigned int DirAttr=GetFileAttr(Name,NameW);
   bool ResetAttr=(DirAttr!=0xffffffff && (DirAttr & FA_RDONLY)!=0);
   if (ResetAttr)
-    SetFileAttr(Name,NULL,0);
-  HANDLE hFile=CreateFile(Name,GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,
+    SetFileAttr(Name,NameW,0);
+
+  wchar DirNameW[NM];
+  GetWideName(Name,NameW,DirNameW);
+  HANDLE hFile=CreateFileW(DirNameW,GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,
                           NULL,OPEN_EXISTING,FILE_FLAG_BACKUP_SEMANTICS,NULL);
   if (hFile==INVALID_HANDLE_VALUE)
     return;
@@ -137,7 +140,7 @@
   SetFileTime(hFile,sc ? &fc:NULL,sa ? &fa:NULL,sm ? &fm:NULL);
   CloseHandle(hFile);
   if (ResetAttr)
-    SetFileAttr(Name,NULL,DirAttr);
+    SetFileAttr(Name,NameW,DirAttr);
 #endif
 #if defined(_UNIX) || defined(_EMX)
   File::SetCloseFileTimeByName(Name,ftm,fta);
@@ -455,7 +458,7 @@
 #ifndef SFX_MODULE
 char *MkTemp(char *Name)
 {
-  int Length=strlen(Name);
+  size_t Length=strlen(Name);
   if (Length<=6)
     return(NULL);
   int Random=clock();
@@ -550,7 +553,7 @@
 }
 
 
-#if defined(_WIN_32) && !defined(_WIN_CE)
+#if defined(_WIN_32) && !defined(_WIN_CE) && !defined(SFX_MODULE)
 bool SetFileCompression(char *Name,wchar *NameW,bool State)
 {
   wchar FileNameW[NM];
@@ -568,3 +571,9 @@
   return(RetCode!=0);
 }
 #endif
+
+
+
+
+
+
diff -uNr unrar/filefn.hpp unrar/filefn.hpp
--- unrar/filefn.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/filefn.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -5,7 +5,7 @@
 
 MKDIR_CODE MakeDir(const char *Name,const wchar *NameW,uint Attr);
 bool CreatePath(const char *Path,const wchar *PathW,bool SkipLastName);
-void SetDirTime(const char *Name,RarTime *ftm,RarTime *ftc,RarTime *fta);
+void SetDirTime(const char *Name,const wchar *NameW,RarTime *ftm,RarTime *ftc,RarTime *fta);
 bool IsRemovable(const char *Name);
 Int64 GetFreeDisk(const char *Name);
 bool FileExist(const char *Name,const wchar *NameW=NULL);
@@ -38,4 +38,7 @@
 bool SetFileCompression(char *Name,wchar *NameW,bool State);
 #endif
 
+
+
+
 #endif
diff -uNr unrar/file.hpp unrar/file.hpp
--- unrar/file.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/file.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -56,13 +56,13 @@
     bool Open(const char *Name,const wchar *NameW=NULL,bool OpenShared=false,bool Update=false);
     void TOpen(const char *Name,const wchar *NameW=NULL);
     bool WOpen(const char *Name,const wchar *NameW=NULL);
-    bool Create(const char *Name,const wchar *NameW=NULL);
-    void TCreate(const char *Name,const wchar *NameW=NULL);
-    bool WCreate(const char *Name,const wchar *NameW=NULL);
+    bool Create(const char *Name,const wchar *NameW=NULL,bool ShareRead=true);
+    void TCreate(const char *Name,const wchar *NameW=NULL,bool ShareRead=true);
+    bool WCreate(const char *Name,const wchar *NameW=NULL,bool ShareRead=true);
     bool Close();
     void Flush();
     bool Delete();
-    bool Rename(const char *NewName);
+    bool Rename(const char *NewName,const wchar *NewNameW=NULL);
     void Write(const void *Data,int Size);
     int Read(void *Data,int Size);
     int DirectRead(void *Data,int Size);
diff -uNr unrar/filestr.cpp unrar/filestr.cpp
--- unrar/filestr.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/filestr.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -3,7 +3,8 @@
 static bool IsUnicode(byte *Data,int Size);
 
 bool ReadTextFile(char *Name,StringList *List,bool Config,bool AbortOnError,
-                  RAR_CHARSET SrcCharset,bool Unquote,bool SkipComments)
+                  RAR_CHARSET SrcCharset,bool Unquote,bool SkipComments,
+                  bool ExpandEnvStr)
 {
   char FileName[NM];
   if (Config)
@@ -19,7 +20,7 @@
     if (!OpenCode)
     {
       if (AbortOnError)
-        ErrHandler.Exit(RAR_OPEN_ERROR);
+        ErrHandler.Exit(OPEN_ERROR);
       return(false);
     }
   }
@@ -79,7 +80,28 @@
           CurStr++;
         }
         WideToChar(CurStr,&AnsiName[0],AnsiName.Size());
-        List->AddString(&AnsiName[0],CurStr);
+
+        bool Expanded=false;
+#if defined(_WIN_32) && !defined(_WIN_CE)
+        if (ExpandEnvStr && *CurStr=='%')
+        {
+          // expanding environment variables in Windows version
+
+          char ExpName[NM];
+          wchar ExpNameW[NM];
+          *ExpNameW=0;
+          int ret,retw=1;
+          ret=ExpandEnvironmentStrings(&AnsiName[0],ExpName,ASIZE(ExpName));
+          if (ret!=0 && WinNT())
+            retw=ExpandEnvironmentStringsW(CurStr,ExpNameW,ASIZE(ExpNameW));
+          Expanded=ret!=0 && ret<ASIZE(ExpName) &&
+                   retw!=0 && retw<ASIZE(ExpNameW);
+          if (Expanded)
+            List->AddString(ExpName,ExpNameW);
+        }
+#endif
+        if (!Expanded)
+          List->AddString(&AnsiName[0],CurStr);
       }
       CurStr=NextStr+1;
       while (*CurStr=='\r' || *CurStr=='\n')
@@ -112,7 +134,7 @@
       {
         if (Unquote && *CurStr=='\"')
         {
-          int Length=strlen(CurStr);
+          size_t Length=strlen(CurStr);
           if (CurStr[Length-1]=='\"')
           {
             CurStr[Length-1]=0;
@@ -123,7 +145,22 @@
         if (SrcCharset==RCH_OEM)
           OemToChar(CurStr,CurStr);
 #endif
-        List->AddString(CurStr);
+
+        bool Expanded=false;
+#if defined(_WIN_32) && !defined(_WIN_CE)
+        if (ExpandEnvStr && *CurStr=='%')
+        {
+          // expanding environment variables in Windows version
+
+          char ExpName[NM];
+          int ret=ExpandEnvironmentStrings(CurStr,ExpName,ASIZE(ExpName));
+          Expanded=ret!=0 && ret<ASIZE(ExpName);
+          if (Expanded)
+            List->AddString(ExpName);
+        }
+#endif
+        if (!Expanded)
+          List->AddString(CurStr);
       }
       CurStr=NextStr+1;
       while (*CurStr=='\r' || *CurStr=='\n')
diff -uNr unrar/filestr.hpp unrar/filestr.hpp
--- unrar/filestr.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/filestr.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -3,6 +3,7 @@
 
 bool ReadTextFile(char *Name,StringList *List,bool Config,
                   bool AbortOnError=false,RAR_CHARSET SrcCharset=RCH_DEFAULT,
-                  bool Unquote=false,bool SkipComments=false);
+                  bool Unquote=false,bool SkipComments=false,
+                  bool ExpandEnvStr=false);
 
 #endif
diff -uNr unrar/find.cpp unrar/find.cpp
--- unrar/find.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/find.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -4,7 +4,7 @@
 {
   *FindMask=0;
   *FindMaskW=0;
-  FirstCall=TRUE;
+  FirstCall=true;
 #ifdef _WIN_32
   hFind=INVALID_HANDLE_VALUE;
 #else
@@ -30,7 +30,7 @@
   strcpy(FindFile::FindMask,FindMask);
   if (*FindMaskW==0)
     CharToWide(FindMask,FindMaskW);
-  FirstCall=TRUE;
+  FirstCall=true;
 }
 
 
@@ -41,7 +41,7 @@
   strcpyw(FindFile::FindMaskW,FindMaskW);
   if (*FindMask==0)
     WideToChar(FindMaskW,FindMask);
-  FirstCall=TRUE;
+  FirstCall=true;
 }
 
 
@@ -120,8 +120,9 @@
     CharToWide(fd->Name,fd->NameW);
 #endif
 #endif
+  fd->Flags=0;
   fd->IsDir=IsDir(fd->FileAttr);
-  FirstCall=FALSE;
+  FirstCall=false;
   char *Name=PointToName(fd->Name);
   if (strcmp(Name,".")==0 || strcmp(Name,"..")==0)
     return(Next(fd));
@@ -185,6 +186,7 @@
     CharToWide(fd->Name,fd->NameW);
 #endif
 #endif
+  fd->Flags=0;
   fd->IsDir=IsDir(fd->FileAttr);
   return(true);
 }
@@ -290,6 +292,7 @@
     }
   }
 #endif
+  fd->Flags=0;
   return(hFind);
 }
 #endif
diff -uNr unrar/find.hpp unrar/find.hpp
--- unrar/find.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/find.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -1,6 +1,10 @@
 #ifndef _RAR_FINDDATA_
 #define _RAR_FINDDATA_
 
+enum FINDDATA_FLAGS {
+  FDDF_SECONDDIR=1  // second entry of directory in SCAN_GETDIRSTWICE ScanTree mode
+};
+
 struct FindData
 {
   char Name[NM];
@@ -18,6 +22,7 @@
   FILETIME ftLastAccessTime; 
   FILETIME ftLastWriteTime; 
 #endif
+  uint Flags;
   bool Error;
 };
 
@@ -30,7 +35,7 @@
 
     char FindMask[NM];
     wchar FindMaskW[NM];
-    int FirstCall;
+    bool FirstCall;
 #ifdef _WIN_32
     HANDLE hFind;
 #else
diff -uNr unrar/headers.hpp unrar/headers.hpp
--- unrar/headers.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/headers.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -65,9 +65,9 @@
 #define  LONG_BLOCK         0x8000
 
 #define  EARC_NEXT_VOLUME   0x0001 // not last volume
-#define  EARC_DATACRC       0x0002
-#define  EARC_REVSPACE      0x0004
-#define  EARC_VOLNUMBER     0x0008
+#define  EARC_DATACRC       0x0002 // store CRC32 of RAR archive (now used only in volumes)
+#define  EARC_REVSPACE      0x0004 // reserve space for end of REV file 7 byte record
+#define  EARC_VOLNUMBER     0x0008 // store a number of current volume
 
 enum HEADER_TYPE {
   MARK_HEAD=0x72,MAIN_HEAD=0x73,FILE_HEAD=0x74,COMM_HEAD=0x75,AV_HEAD=0x76,
@@ -218,11 +218,13 @@
 
 struct EndArcHeader:BaseBlock
 {
-  uint ArcDataCRC;
-  ushort VolNumber;
+  uint ArcDataCRC;  // optional archive CRC32
+  ushort VolNumber; // optional current volume number
 };
 
 
+// SubBlockHeader and its successors were used in RAR 2.x format.
+// RAR 3.x uses FileHeader with NEWSUB_HEAD HeadType for subblocks.
 struct SubBlockHeader:BlockHeader
 {
   ushort SubType;
diff -uNr unrar/list.cpp unrar/list.cpp
--- unrar/list.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/list.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -270,13 +270,20 @@
 void ListSymLink(Archive &Arc)
 {
   if (Arc.NewLhd.HostOS==HOST_UNIX && (Arc.NewLhd.FileAttr & 0xF000)==0xA000)
-  {
-    char FileName[NM];
-    int DataSize=Min(Arc.NewLhd.PackSize,sizeof(FileName)-1);
-    Arc.Read(FileName,DataSize);
-    FileName[DataSize]=0;
-    mprintf("\n%22s %s","-->",FileName);
-  }
+    if ((Arc.NewLhd.Flags & LHD_PASSWORD)==0)
+    {
+      char FileName[NM];
+      int DataSize=Min(Arc.NewLhd.PackSize,sizeof(FileName)-1);
+      Arc.Read(FileName,DataSize);
+      FileName[DataSize]=0;
+      mprintf("\n%22s %s","-->",FileName);
+    }
+    else
+    {
+      // Link data are encrypted. We would need to ask for password
+      // and initialize decryption routine to display the link target.
+      mprintf("\n%22s %s","-->","*<-?->");
+    }
 }
 
 
diff -uNr unrar/loclang.hpp unrar/loclang.hpp
--- unrar/loclang.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/loclang.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -1,5 +1,6 @@
 #define   MYesNo             "_Yes_No"
 #define   MYesNoAll          "_Yes_No_All"
+#define   MYesNoAllQ         "_Yes_No_All_nEver_Quit"
 #define   MYesNoAllRenQ      "_Yes_No_All_nEver_Rename_Quit"
 #define   MContinueQuit      "_Continue_Quit"
 #define   MRetryAbort        "_Retry_Abort"
@@ -63,7 +64,9 @@
 #define   MCHelpSwCU         "\n  cu            Convert names to upper case"
 #define   MCHelpSwDF         "\n  df            Delete files after archiving"
 #define   MCHelpSwDH         "\n  dh            Open shared files"
+#define   MCHelpSwDR         "\n  dr            Delete files to Recycle Bin"
 #define   MCHelpSwDS         "\n  ds            Disable name sort for solid archive"
+#define   MCHelpSwDW         "\n  dw            Wipe files after archiving"
 #define   MCHelpSwEa         "\n  e[+]<attr>    Set file exclude and include attributes"
 #define   MCHelpSwED         "\n  ed            Do not add empty directories"
 #define   MCHelpSwEE         "\n  ee            Do not save and extract extended attributes"
@@ -91,8 +94,7 @@
 #define   MCHelpSwN          "\n  n<file>       Include only specified file"
 #define   MCHelpSwNa         "\n  n@            Read file names to include from stdin"
 #define   MCHelpSwNal        "\n  n@<list>      Include files in specified list file"
-#define   MCHelpSwOp         "\n  o+            Overwrite existing files"
-#define   MCHelpSwOm         "\n  o-            Do not overwrite existing files"
+#define   MCHelpSwO          "\n  o[+|-]        Set the overwrite mode"
 #define   MCHelpSwOC         "\n  oc            Set NTFS Compressed attribute"
 #define   MCHelpSwOL         "\n  ol            Save symbolic links as the link instead of the file"
 #define   MCHelpSwOR         "\n  or            Rename files automatically"
@@ -347,3 +349,4 @@
 #define   MCannotDelete      "\nCannot delete %s"
 #define   MCalcCRC           "\nCalculating the control sum"
 #define   MTooLargeSFXArc    "\nWARNING: Too large SFX archive. Windows cannot run the executable file exceeding 4 GB."
+#define   MCalcCRCAllVol     "\nCalculating control sums of all volumes."
